# This file was automatically generated by `python.ts`.
# Do not modify it by hand. Instead, modify the source `.schema.yaml` files
# in the `schema` directory and run `npm run build:py` to regenerate it.
"""Python classes for schema types."""

from typing import Any, Dict, List as Array, Optional, Union
from enum import Enum

ECitationMode = Enum("CitationMode", ["normal", "suppressAuthor"])

EItemListOrder = Enum("ItemListOrder", ["ascending", "descending", "unordered"])

ESessionStatus = Enum("SessionStatus", ["unknown", "starting", "started", "stopping", "stopped", "failed"])

ECellType = Enum("CellType", ["data", "header"])

ERowType = Enum("RowType", ["header", "footer"])


class Entity:
    """
    The most simple compound (ie. non-atomic like `number`, `string` etc) type.
    """

    id: Optional[str] = None
    meta: Optional[Dict[str, Any]] = None

    def __init__(
        self,
        id: Optional[str] = None,
        meta: Optional[Dict[str, Any]] = None
    ) -> None:
        super().__init__(

        )
        if id is not None:
            self.id = id
        if meta is not None:
            self.meta = meta


class ArrayValidator(Entity):
    """A validator specifying constraints on an array node."""

    contains: Optional["ValidatorTypes"] = None
    items: Optional["ValidatorTypes"] = None
    maxItems: Optional[float] = None
    minItems: Optional[float] = None
    uniqueItems: Optional[bool] = None

    def __init__(
        self,
        contains: Optional["ValidatorTypes"] = None,
        id: Optional[str] = None,
        items: Optional["ValidatorTypes"] = None,
        maxItems: Optional[float] = None,
        meta: Optional[Dict[str, Any]] = None,
        minItems: Optional[float] = None,
        uniqueItems: Optional[bool] = None
    ) -> None:
        super().__init__(
            id=id,
            meta=meta
        )
        if contains is not None:
            self.contains = contains
        if items is not None:
            self.items = items
        if maxItems is not None:
            self.maxItems = maxItems
        if minItems is not None:
            self.minItems = minItems
        if uniqueItems is not None:
            self.uniqueItems = uniqueItems


class BooleanValidator(Entity):
    """A schema specifying that a node must be a boolean value."""

    def __init__(
        self,
        id: Optional[str] = None,
        meta: Optional[Dict[str, Any]] = None
    ) -> None:
        super().__init__(
            id=id,
            meta=meta
        )



class Cite(Entity):
    """A reference to a CreativeWork that is cited in another CreativeWork."""

    target: str
    citationMode: Optional["ECitationMode"] = None
    content: Optional[Array["InlineContent"]] = None
    pageEnd: Optional[Union[str, int]] = None
    pageStart: Optional[Union[str, int]] = None
    pagination: Optional[str] = None
    prefix: Optional[str] = None
    suffix: Optional[str] = None

    def __init__(
        self,
        target: str,
        citationMode: Optional["ECitationMode"] = None,
        content: Optional[Array["InlineContent"]] = None,
        id: Optional[str] = None,
        meta: Optional[Dict[str, Any]] = None,
        pageEnd: Optional[Union[str, int]] = None,
        pageStart: Optional[Union[str, int]] = None,
        pagination: Optional[str] = None,
        prefix: Optional[str] = None,
        suffix: Optional[str] = None
    ) -> None:
        super().__init__(
            id=id,
            meta=meta
        )
        if target is not None:
            self.target = target
        if citationMode is not None:
            self.citationMode = citationMode
        if content is not None:
            self.content = content
        if pageEnd is not None:
            self.pageEnd = pageEnd
        if pageStart is not None:
            self.pageStart = pageStart
        if pagination is not None:
            self.pagination = pagination
        if prefix is not None:
            self.prefix = prefix
        if suffix is not None:
            self.suffix = suffix


class CiteGroup(Entity):
    """A group of `Cite` nodes"""

    items: Array["Cite"]

    def __init__(
        self,
        items: Array["Cite"],
        id: Optional[str] = None,
        meta: Optional[Dict[str, Any]] = None
    ) -> None:
        super().__init__(
            id=id,
            meta=meta
        )
        if items is not None:
            self.items = items


class Code(Entity):
    """Base type for code nodes e.g. `CodeBlock`, `CodeExpression`."""

    text: str
    format: Optional[str] = None
    programmingLanguage: Optional[str] = None

    def __init__(
        self,
        text: str,
        format: Optional[str] = None,
        id: Optional[str] = None,
        meta: Optional[Dict[str, Any]] = None,
        programmingLanguage: Optional[str] = None
    ) -> None:
        super().__init__(
            id=id,
            meta=meta
        )
        if text is not None:
            self.text = text
        if format is not None:
            self.format = format
        if programmingLanguage is not None:
            self.programmingLanguage = programmingLanguage


class CodeBlock(Code):
    """A code block."""

    exportFrom: Optional[str] = None
    importTo: Optional[str] = None

    def __init__(
        self,
        text: str,
        exportFrom: Optional[str] = None,
        format: Optional[str] = None,
        id: Optional[str] = None,
        importTo: Optional[str] = None,
        meta: Optional[Dict[str, Any]] = None,
        programmingLanguage: Optional[str] = None
    ) -> None:
        super().__init__(
            text=text,
            format=format,
            id=id,
            meta=meta,
            programmingLanguage=programmingLanguage
        )
        if exportFrom is not None:
            self.exportFrom = exportFrom
        if importTo is not None:
            self.importTo = importTo


class CodeChunk(CodeBlock):
    """A executable chunk of code."""

    alters: Optional[Array[str]] = None
    assigns: Optional[Array[Union[str, "Variable"]]] = None
    declares: Optional[Array[Union[str, "Variable", "Function"]]] = None
    duration: Optional[float] = None
    errors: Optional[Array["CodeError"]] = None
    imports: Optional[Array[Union[str, "SoftwareSourceCode", "SoftwareApplication"]]] = None
    outputs: Optional[Array["Node"]] = None
    reads: Optional[Array[str]] = None
    uses: Optional[Array[Union[str, "Variable"]]] = None

    def __init__(
        self,
        text: str,
        alters: Optional[Array[str]] = None,
        assigns: Optional[Array[Union[str, "Variable"]]] = None,
        declares: Optional[Array[Union[str, "Variable", "Function"]]] = None,
        duration: Optional[float] = None,
        errors: Optional[Array["CodeError"]] = None,
        exportFrom: Optional[str] = None,
        format: Optional[str] = None,
        id: Optional[str] = None,
        importTo: Optional[str] = None,
        imports: Optional[Array[Union[str, "SoftwareSourceCode", "SoftwareApplication"]]] = None,
        meta: Optional[Dict[str, Any]] = None,
        outputs: Optional[Array["Node"]] = None,
        programmingLanguage: Optional[str] = None,
        reads: Optional[Array[str]] = None,
        uses: Optional[Array[Union[str, "Variable"]]] = None
    ) -> None:
        super().__init__(
            text=text,
            exportFrom=exportFrom,
            format=format,
            id=id,
            importTo=importTo,
            meta=meta,
            programmingLanguage=programmingLanguage
        )
        if alters is not None:
            self.alters = alters
        if assigns is not None:
            self.assigns = assigns
        if declares is not None:
            self.declares = declares
        if duration is not None:
            self.duration = duration
        if errors is not None:
            self.errors = errors
        if imports is not None:
            self.imports = imports
        if outputs is not None:
            self.outputs = outputs
        if reads is not None:
            self.reads = reads
        if uses is not None:
            self.uses = uses


class CodeFragment(Code):
    """Inline code."""

    def __init__(
        self,
        text: str,
        format: Optional[str] = None,
        id: Optional[str] = None,
        meta: Optional[Dict[str, Any]] = None,
        programmingLanguage: Optional[str] = None
    ) -> None:
        super().__init__(
            text=text,
            format=format,
            id=id,
            meta=meta,
            programmingLanguage=programmingLanguage
        )



class CodeExpression(CodeFragment):
    """An expression defined in programming language source code."""

    errors: Optional[Array["CodeError"]] = None
    output: Optional["Node"] = None

    def __init__(
        self,
        text: str,
        errors: Optional[Array["CodeError"]] = None,
        format: Optional[str] = None,
        id: Optional[str] = None,
        meta: Optional[Dict[str, Any]] = None,
        output: Optional["Node"] = None,
        programmingLanguage: Optional[str] = None
    ) -> None:
        super().__init__(
            text=text,
            format=format,
            id=id,
            meta=meta,
            programmingLanguage=programmingLanguage
        )
        if errors is not None:
            self.errors = errors
        if output is not None:
            self.output = output


class CodeError(Entity):
    """
    An error that occurred when parsing, compiling or executing a Code node.
    """

    errorMessage: Optional[str] = None
    errorType: Optional[str] = None
    stackTrace: Optional[str] = None

    def __init__(
        self,
        errorMessage: Optional[str] = None,
        errorType: Optional[str] = None,
        id: Optional[str] = None,
        meta: Optional[Dict[str, Any]] = None,
        stackTrace: Optional[str] = None
    ) -> None:
        super().__init__(
            id=id,
            meta=meta
        )
        if errorMessage is not None:
            self.errorMessage = errorMessage
        if errorType is not None:
            self.errorType = errorType
        if stackTrace is not None:
            self.stackTrace = stackTrace


class ConstantValidator(Entity):
    """A validator specifying a constant value that a node must have."""

    value: Optional["Node"] = None

    def __init__(
        self,
        id: Optional[str] = None,
        meta: Optional[Dict[str, Any]] = None,
        value: Optional["Node"] = None
    ) -> None:
        super().__init__(
            id=id,
            meta=meta
        )
        if value is not None:
            self.value = value


class Date(Entity):
    """A date encoded as a ISO 8601 string."""

    value: str

    def __init__(
        self,
        value: str,
        id: Optional[str] = None,
        meta: Optional[Dict[str, Any]] = None
    ) -> None:
        super().__init__(
            id=id,
            meta=meta
        )
        if value is not None:
            self.value = value


class Mark(Entity):
    """
    A base class for nodes that mark some other inline content in some way
    (e.g. as being emphasised, or quoted).
    """

    content: Array["InlineContent"]

    def __init__(
        self,
        content: Array["InlineContent"],
        id: Optional[str] = None,
        meta: Optional[Dict[str, Any]] = None
    ) -> None:
        super().__init__(
            id=id,
            meta=meta
        )
        if content is not None:
            self.content = content


class Delete(Mark):
    """Content that is marked for deletion"""

    def __init__(
        self,
        content: Array["InlineContent"],
        id: Optional[str] = None,
        meta: Optional[Dict[str, Any]] = None
    ) -> None:
        super().__init__(
            content=content,
            id=id,
            meta=meta
        )



class Emphasis(Mark):
    """Emphasised content."""

    def __init__(
        self,
        content: Array["InlineContent"],
        id: Optional[str] = None,
        meta: Optional[Dict[str, Any]] = None
    ) -> None:
        super().__init__(
            content=content,
            id=id,
            meta=meta
        )



class Thing(Entity):
    """The most generic type of item."""

    alternateNames: Optional[Array[str]] = None
    description: Optional[Union[str, Array["Node"]]] = None
    identifiers: Optional[Array[Union[str, "PropertyValue"]]] = None
    name: Optional[str] = None
    url: Optional[str] = None

    def __init__(
        self,
        alternateNames: Optional[Array[str]] = None,
        description: Optional[Union[str, Array["Node"]]] = None,
        id: Optional[str] = None,
        identifiers: Optional[Array[Union[str, "PropertyValue"]]] = None,
        meta: Optional[Dict[str, Any]] = None,
        name: Optional[str] = None,
        url: Optional[str] = None
    ) -> None:
        super().__init__(
            id=id,
            meta=meta
        )
        if alternateNames is not None:
            self.alternateNames = alternateNames
        if description is not None:
            self.description = description
        if identifiers is not None:
            self.identifiers = identifiers
        if name is not None:
            self.name = name
        if url is not None:
            self.url = url


class Brand(Thing):
    """
    A brand used by an organization or person for labeling a product, product
    group, or similar.
    """

    name: str
    logo: Optional[Union[str, "ImageObject"]] = None
    reviews: Optional[Array[str]] = None

    def __init__(
        self,
        name: str,
        alternateNames: Optional[Array[str]] = None,
        description: Optional[Union[str, Array["Node"]]] = None,
        id: Optional[str] = None,
        identifiers: Optional[Array[Union[str, "PropertyValue"]]] = None,
        logo: Optional[Union[str, "ImageObject"]] = None,
        meta: Optional[Dict[str, Any]] = None,
        reviews: Optional[Array[str]] = None,
        url: Optional[str] = None
    ) -> None:
        super().__init__(
            name=name,
            alternateNames=alternateNames,
            description=description,
            id=id,
            identifiers=identifiers,
            meta=meta,
            url=url
        )
        if name is not None:
            self.name = name
        if logo is not None:
            self.logo = logo
        if reviews is not None:
            self.reviews = reviews


class ContactPoint(Thing):
    """A contact point, for example, a R&D department."""

    availableLanguages: Optional[Array[str]] = None
    emails: Optional[Array[str]] = None
    telephoneNumbers: Optional[Array[str]] = None

    def __init__(
        self,
        alternateNames: Optional[Array[str]] = None,
        availableLanguages: Optional[Array[str]] = None,
        description: Optional[Union[str, Array["Node"]]] = None,
        emails: Optional[Array[str]] = None,
        id: Optional[str] = None,
        identifiers: Optional[Array[Union[str, "PropertyValue"]]] = None,
        meta: Optional[Dict[str, Any]] = None,
        name: Optional[str] = None,
        telephoneNumbers: Optional[Array[str]] = None,
        url: Optional[str] = None
    ) -> None:
        super().__init__(
            alternateNames=alternateNames,
            description=description,
            id=id,
            identifiers=identifiers,
            meta=meta,
            name=name,
            url=url
        )
        if availableLanguages is not None:
            self.availableLanguages = availableLanguages
        if emails is not None:
            self.emails = emails
        if telephoneNumbers is not None:
            self.telephoneNumbers = telephoneNumbers


class CreativeWork(Thing):
    """
    A creative work, including books, movies, photographs, software programs,
    etc.
    """

    authors: Optional[Array[Union["Person", "Organization"]]] = None
    content: Optional[Array["Node"]] = None
    dateAccepted: Optional[Union["Date", str]] = None
    dateCreated: Optional[Union["Date", str]] = None
    dateModified: Optional[Union["Date", str]] = None
    datePublished: Optional[Union["Date", str]] = None
    dateReceived: Optional[Union["Date", str]] = None
    editors: Optional[Array["Person"]] = None
    fundedBy: Optional[Array[Union["Grant", "MonetaryGrant"]]] = None
    funders: Optional[Array[Union["Person", "Organization"]]] = None
    isPartOf: Optional["CreativeWorkTypes"] = None
    keywords: Optional[Array[str]] = None
    licenses: Optional[Array[Union[str, "CreativeWorkTypes"]]] = None
    parts: Optional[Array["CreativeWorkTypes"]] = None
    publisher: Optional[Union["Person", "Organization"]] = None
    references: Optional[Array[Union[str, "CreativeWorkTypes"]]] = None
    text: Optional[str] = None
    title: Optional[Union[str, Array["Node"]]] = None
    version: Optional[Union[str, float]] = None

    def __init__(
        self,
        alternateNames: Optional[Array[str]] = None,
        authors: Optional[Array[Union["Person", "Organization"]]] = None,
        content: Optional[Array["Node"]] = None,
        dateAccepted: Optional[Union["Date", str]] = None,
        dateCreated: Optional[Union["Date", str]] = None,
        dateModified: Optional[Union["Date", str]] = None,
        datePublished: Optional[Union["Date", str]] = None,
        dateReceived: Optional[Union["Date", str]] = None,
        description: Optional[Union[str, Array["Node"]]] = None,
        editors: Optional[Array["Person"]] = None,
        fundedBy: Optional[Array[Union["Grant", "MonetaryGrant"]]] = None,
        funders: Optional[Array[Union["Person", "Organization"]]] = None,
        id: Optional[str] = None,
        identifiers: Optional[Array[Union[str, "PropertyValue"]]] = None,
        isPartOf: Optional["CreativeWorkTypes"] = None,
        keywords: Optional[Array[str]] = None,
        licenses: Optional[Array[Union[str, "CreativeWorkTypes"]]] = None,
        meta: Optional[Dict[str, Any]] = None,
        name: Optional[str] = None,
        parts: Optional[Array["CreativeWorkTypes"]] = None,
        publisher: Optional[Union["Person", "Organization"]] = None,
        references: Optional[Array[Union[str, "CreativeWorkTypes"]]] = None,
        text: Optional[str] = None,
        title: Optional[Union[str, Array["Node"]]] = None,
        url: Optional[str] = None,
        version: Optional[Union[str, float]] = None
    ) -> None:
        super().__init__(
            alternateNames=alternateNames,
            description=description,
            id=id,
            identifiers=identifiers,
            meta=meta,
            name=name,
            url=url
        )
        if authors is not None:
            self.authors = authors
        if content is not None:
            self.content = content
        if dateAccepted is not None:
            self.dateAccepted = dateAccepted
        if dateCreated is not None:
            self.dateCreated = dateCreated
        if dateModified is not None:
            self.dateModified = dateModified
        if datePublished is not None:
            self.datePublished = datePublished
        if dateReceived is not None:
            self.dateReceived = dateReceived
        if editors is not None:
            self.editors = editors
        if fundedBy is not None:
            self.fundedBy = fundedBy
        if funders is not None:
            self.funders = funders
        if isPartOf is not None:
            self.isPartOf = isPartOf
        if keywords is not None:
            self.keywords = keywords
        if licenses is not None:
            self.licenses = licenses
        if parts is not None:
            self.parts = parts
        if publisher is not None:
            self.publisher = publisher
        if references is not None:
            self.references = references
        if text is not None:
            self.text = text
        if title is not None:
            self.title = title
        if version is not None:
            self.version = version


class Article(CreativeWork):
    """An article, including news and scholarly articles."""

    def __init__(
        self,
        alternateNames: Optional[Array[str]] = None,
        authors: Optional[Array[Union["Person", "Organization"]]] = None,
        content: Optional[Array["Node"]] = None,
        dateAccepted: Optional[Union["Date", str]] = None,
        dateCreated: Optional[Union["Date", str]] = None,
        dateModified: Optional[Union["Date", str]] = None,
        datePublished: Optional[Union["Date", str]] = None,
        dateReceived: Optional[Union["Date", str]] = None,
        description: Optional[Union[str, Array["Node"]]] = None,
        editors: Optional[Array["Person"]] = None,
        fundedBy: Optional[Array[Union["Grant", "MonetaryGrant"]]] = None,
        funders: Optional[Array[Union["Person", "Organization"]]] = None,
        id: Optional[str] = None,
        identifiers: Optional[Array[Union[str, "PropertyValue"]]] = None,
        isPartOf: Optional["CreativeWorkTypes"] = None,
        keywords: Optional[Array[str]] = None,
        licenses: Optional[Array[Union[str, "CreativeWorkTypes"]]] = None,
        meta: Optional[Dict[str, Any]] = None,
        name: Optional[str] = None,
        parts: Optional[Array["CreativeWorkTypes"]] = None,
        publisher: Optional[Union["Person", "Organization"]] = None,
        references: Optional[Array[Union[str, "CreativeWorkTypes"]]] = None,
        text: Optional[str] = None,
        title: Optional[Union[str, Array["Node"]]] = None,
        url: Optional[str] = None,
        version: Optional[Union[str, float]] = None
    ) -> None:
        super().__init__(
            alternateNames=alternateNames,
            authors=authors,
            content=content,
            dateAccepted=dateAccepted,
            dateCreated=dateCreated,
            dateModified=dateModified,
            datePublished=datePublished,
            dateReceived=dateReceived,
            description=description,
            editors=editors,
            fundedBy=fundedBy,
            funders=funders,
            id=id,
            identifiers=identifiers,
            isPartOf=isPartOf,
            keywords=keywords,
            licenses=licenses,
            meta=meta,
            name=name,
            parts=parts,
            publisher=publisher,
            references=references,
            text=text,
            title=title,
            url=url,
            version=version
        )



class Collection(CreativeWork):
    """A created collection of CreativeWorks or other artefacts."""

    parts: Array["CreativeWorkTypes"]

    def __init__(
        self,
        parts: Array["CreativeWorkTypes"],
        alternateNames: Optional[Array[str]] = None,
        authors: Optional[Array[Union["Person", "Organization"]]] = None,
        content: Optional[Array["Node"]] = None,
        dateAccepted: Optional[Union["Date", str]] = None,
        dateCreated: Optional[Union["Date", str]] = None,
        dateModified: Optional[Union["Date", str]] = None,
        datePublished: Optional[Union["Date", str]] = None,
        dateReceived: Optional[Union["Date", str]] = None,
        description: Optional[Union[str, Array["Node"]]] = None,
        editors: Optional[Array["Person"]] = None,
        fundedBy: Optional[Array[Union["Grant", "MonetaryGrant"]]] = None,
        funders: Optional[Array[Union["Person", "Organization"]]] = None,
        id: Optional[str] = None,
        identifiers: Optional[Array[Union[str, "PropertyValue"]]] = None,
        isPartOf: Optional["CreativeWorkTypes"] = None,
        keywords: Optional[Array[str]] = None,
        licenses: Optional[Array[Union[str, "CreativeWorkTypes"]]] = None,
        meta: Optional[Dict[str, Any]] = None,
        name: Optional[str] = None,
        publisher: Optional[Union["Person", "Organization"]] = None,
        references: Optional[Array[Union[str, "CreativeWorkTypes"]]] = None,
        text: Optional[str] = None,
        title: Optional[Union[str, Array["Node"]]] = None,
        url: Optional[str] = None,
        version: Optional[Union[str, float]] = None
    ) -> None:
        super().__init__(
            parts=parts,
            alternateNames=alternateNames,
            authors=authors,
            content=content,
            dateAccepted=dateAccepted,
            dateCreated=dateCreated,
            dateModified=dateModified,
            datePublished=datePublished,
            dateReceived=dateReceived,
            description=description,
            editors=editors,
            fundedBy=fundedBy,
            funders=funders,
            id=id,
            identifiers=identifiers,
            isPartOf=isPartOf,
            keywords=keywords,
            licenses=licenses,
            meta=meta,
            name=name,
            publisher=publisher,
            references=references,
            text=text,
            title=title,
            url=url,
            version=version
        )
        if parts is not None:
            self.parts = parts


class Datatable(CreativeWork):
    """A table of data."""

    columns: Array["DatatableColumn"]

    def __init__(
        self,
        columns: Array["DatatableColumn"],
        alternateNames: Optional[Array[str]] = None,
        authors: Optional[Array[Union["Person", "Organization"]]] = None,
        content: Optional[Array["Node"]] = None,
        dateAccepted: Optional[Union["Date", str]] = None,
        dateCreated: Optional[Union["Date", str]] = None,
        dateModified: Optional[Union["Date", str]] = None,
        datePublished: Optional[Union["Date", str]] = None,
        dateReceived: Optional[Union["Date", str]] = None,
        description: Optional[Union[str, Array["Node"]]] = None,
        editors: Optional[Array["Person"]] = None,
        fundedBy: Optional[Array[Union["Grant", "MonetaryGrant"]]] = None,
        funders: Optional[Array[Union["Person", "Organization"]]] = None,
        id: Optional[str] = None,
        identifiers: Optional[Array[Union[str, "PropertyValue"]]] = None,
        isPartOf: Optional["CreativeWorkTypes"] = None,
        keywords: Optional[Array[str]] = None,
        licenses: Optional[Array[Union[str, "CreativeWorkTypes"]]] = None,
        meta: Optional[Dict[str, Any]] = None,
        name: Optional[str] = None,
        parts: Optional[Array["CreativeWorkTypes"]] = None,
        publisher: Optional[Union["Person", "Organization"]] = None,
        references: Optional[Array[Union[str, "CreativeWorkTypes"]]] = None,
        text: Optional[str] = None,
        title: Optional[Union[str, Array["Node"]]] = None,
        url: Optional[str] = None,
        version: Optional[Union[str, float]] = None
    ) -> None:
        super().__init__(
            alternateNames=alternateNames,
            authors=authors,
            content=content,
            dateAccepted=dateAccepted,
            dateCreated=dateCreated,
            dateModified=dateModified,
            datePublished=datePublished,
            dateReceived=dateReceived,
            description=description,
            editors=editors,
            fundedBy=fundedBy,
            funders=funders,
            id=id,
            identifiers=identifiers,
            isPartOf=isPartOf,
            keywords=keywords,
            licenses=licenses,
            meta=meta,
            name=name,
            parts=parts,
            publisher=publisher,
            references=references,
            text=text,
            title=title,
            url=url,
            version=version
        )
        if columns is not None:
            self.columns = columns


class MediaObject(CreativeWork):
    """
    A media object, such as an image, video, or audio object embedded in a web
    page or a downloadable dataset.
    """

    contentUrl: str
    bitrate: Optional[float] = None
    contentSize: Optional[float] = None
    embedUrl: Optional[str] = None
    format: Optional[str] = None

    def __init__(
        self,
        contentUrl: str,
        alternateNames: Optional[Array[str]] = None,
        authors: Optional[Array[Union["Person", "Organization"]]] = None,
        bitrate: Optional[float] = None,
        content: Optional[Array["Node"]] = None,
        contentSize: Optional[float] = None,
        dateAccepted: Optional[Union["Date", str]] = None,
        dateCreated: Optional[Union["Date", str]] = None,
        dateModified: Optional[Union["Date", str]] = None,
        datePublished: Optional[Union["Date", str]] = None,
        dateReceived: Optional[Union["Date", str]] = None,
        description: Optional[Union[str, Array["Node"]]] = None,
        editors: Optional[Array["Person"]] = None,
        embedUrl: Optional[str] = None,
        format: Optional[str] = None,
        fundedBy: Optional[Array[Union["Grant", "MonetaryGrant"]]] = None,
        funders: Optional[Array[Union["Person", "Organization"]]] = None,
        id: Optional[str] = None,
        identifiers: Optional[Array[Union[str, "PropertyValue"]]] = None,
        isPartOf: Optional["CreativeWorkTypes"] = None,
        keywords: Optional[Array[str]] = None,
        licenses: Optional[Array[Union[str, "CreativeWorkTypes"]]] = None,
        meta: Optional[Dict[str, Any]] = None,
        name: Optional[str] = None,
        parts: Optional[Array["CreativeWorkTypes"]] = None,
        publisher: Optional[Union["Person", "Organization"]] = None,
        references: Optional[Array[Union[str, "CreativeWorkTypes"]]] = None,
        text: Optional[str] = None,
        title: Optional[Union[str, Array["Node"]]] = None,
        url: Optional[str] = None,
        version: Optional[Union[str, float]] = None
    ) -> None:
        super().__init__(
            alternateNames=alternateNames,
            authors=authors,
            content=content,
            dateAccepted=dateAccepted,
            dateCreated=dateCreated,
            dateModified=dateModified,
            datePublished=datePublished,
            dateReceived=dateReceived,
            description=description,
            editors=editors,
            fundedBy=fundedBy,
            funders=funders,
            id=id,
            identifiers=identifiers,
            isPartOf=isPartOf,
            keywords=keywords,
            licenses=licenses,
            meta=meta,
            name=name,
            parts=parts,
            publisher=publisher,
            references=references,
            text=text,
            title=title,
            url=url,
            version=version
        )
        if contentUrl is not None:
            self.contentUrl = contentUrl
        if bitrate is not None:
            self.bitrate = bitrate
        if contentSize is not None:
            self.contentSize = contentSize
        if embedUrl is not None:
            self.embedUrl = embedUrl
        if format is not None:
            self.format = format


class AudioObject(MediaObject):
    """An audio file"""

    caption: Optional[str] = None
    transcript: Optional[str] = None

    def __init__(
        self,
        contentUrl: str,
        alternateNames: Optional[Array[str]] = None,
        authors: Optional[Array[Union["Person", "Organization"]]] = None,
        bitrate: Optional[float] = None,
        caption: Optional[str] = None,
        content: Optional[Array["Node"]] = None,
        contentSize: Optional[float] = None,
        dateAccepted: Optional[Union["Date", str]] = None,
        dateCreated: Optional[Union["Date", str]] = None,
        dateModified: Optional[Union["Date", str]] = None,
        datePublished: Optional[Union["Date", str]] = None,
        dateReceived: Optional[Union["Date", str]] = None,
        description: Optional[Union[str, Array["Node"]]] = None,
        editors: Optional[Array["Person"]] = None,
        embedUrl: Optional[str] = None,
        format: Optional[str] = None,
        fundedBy: Optional[Array[Union["Grant", "MonetaryGrant"]]] = None,
        funders: Optional[Array[Union["Person", "Organization"]]] = None,
        id: Optional[str] = None,
        identifiers: Optional[Array[Union[str, "PropertyValue"]]] = None,
        isPartOf: Optional["CreativeWorkTypes"] = None,
        keywords: Optional[Array[str]] = None,
        licenses: Optional[Array[Union[str, "CreativeWorkTypes"]]] = None,
        meta: Optional[Dict[str, Any]] = None,
        name: Optional[str] = None,
        parts: Optional[Array["CreativeWorkTypes"]] = None,
        publisher: Optional[Union["Person", "Organization"]] = None,
        references: Optional[Array[Union[str, "CreativeWorkTypes"]]] = None,
        text: Optional[str] = None,
        title: Optional[Union[str, Array["Node"]]] = None,
        transcript: Optional[str] = None,
        url: Optional[str] = None,
        version: Optional[Union[str, float]] = None
    ) -> None:
        super().__init__(
            contentUrl=contentUrl,
            alternateNames=alternateNames,
            authors=authors,
            bitrate=bitrate,
            content=content,
            contentSize=contentSize,
            dateAccepted=dateAccepted,
            dateCreated=dateCreated,
            dateModified=dateModified,
            datePublished=datePublished,
            dateReceived=dateReceived,
            description=description,
            editors=editors,
            embedUrl=embedUrl,
            format=format,
            fundedBy=fundedBy,
            funders=funders,
            id=id,
            identifiers=identifiers,
            isPartOf=isPartOf,
            keywords=keywords,
            licenses=licenses,
            meta=meta,
            name=name,
            parts=parts,
            publisher=publisher,
            references=references,
            text=text,
            title=title,
            url=url,
            version=version
        )
        if caption is not None:
            self.caption = caption
        if transcript is not None:
            self.transcript = transcript


class DatatableColumn(Thing):
    """A column of data within a Datatable."""

    name: str
    values: Array[Any]
    validator: Optional["ArrayValidator"] = None

    def __init__(
        self,
        name: str,
        values: Array[Any],
        alternateNames: Optional[Array[str]] = None,
        description: Optional[Union[str, Array["Node"]]] = None,
        id: Optional[str] = None,
        identifiers: Optional[Array[Union[str, "PropertyValue"]]] = None,
        meta: Optional[Dict[str, Any]] = None,
        url: Optional[str] = None,
        validator: Optional["ArrayValidator"] = None
    ) -> None:
        super().__init__(
            name=name,
            alternateNames=alternateNames,
            description=description,
            id=id,
            identifiers=identifiers,
            meta=meta,
            url=url
        )
        if name is not None:
            self.name = name
        if values is not None:
            self.values = values
        if validator is not None:
            self.validator = validator


class EnumValidator(Entity):
    """A schema specifying that a node must be one of several values."""

    values: Optional[Array["Node"]] = None

    def __init__(
        self,
        id: Optional[str] = None,
        meta: Optional[Dict[str, Any]] = None,
        values: Optional[Array["Node"]] = None
    ) -> None:
        super().__init__(
            id=id,
            meta=meta
        )
        if values is not None:
            self.values = values


class Figure(CreativeWork):
    """
    Encapsulates one or more images, videos, tables, etc, and provides captions
    and labels for them.
    """

    caption: Optional[Array["Node"]] = None
    label: Optional[str] = None

    def __init__(
        self,
        alternateNames: Optional[Array[str]] = None,
        authors: Optional[Array[Union["Person", "Organization"]]] = None,
        caption: Optional[Array["Node"]] = None,
        content: Optional[Array["Node"]] = None,
        dateAccepted: Optional[Union["Date", str]] = None,
        dateCreated: Optional[Union["Date", str]] = None,
        dateModified: Optional[Union["Date", str]] = None,
        datePublished: Optional[Union["Date", str]] = None,
        dateReceived: Optional[Union["Date", str]] = None,
        description: Optional[Union[str, Array["Node"]]] = None,
        editors: Optional[Array["Person"]] = None,
        fundedBy: Optional[Array[Union["Grant", "MonetaryGrant"]]] = None,
        funders: Optional[Array[Union["Person", "Organization"]]] = None,
        id: Optional[str] = None,
        identifiers: Optional[Array[Union[str, "PropertyValue"]]] = None,
        isPartOf: Optional["CreativeWorkTypes"] = None,
        keywords: Optional[Array[str]] = None,
        label: Optional[str] = None,
        licenses: Optional[Array[Union[str, "CreativeWorkTypes"]]] = None,
        meta: Optional[Dict[str, Any]] = None,
        name: Optional[str] = None,
        parts: Optional[Array["CreativeWorkTypes"]] = None,
        publisher: Optional[Union["Person", "Organization"]] = None,
        references: Optional[Array[Union[str, "CreativeWorkTypes"]]] = None,
        text: Optional[str] = None,
        title: Optional[Union[str, Array["Node"]]] = None,
        url: Optional[str] = None,
        version: Optional[Union[str, float]] = None
    ) -> None:
        super().__init__(
            alternateNames=alternateNames,
            authors=authors,
            content=content,
            dateAccepted=dateAccepted,
            dateCreated=dateCreated,
            dateModified=dateModified,
            datePublished=datePublished,
            dateReceived=dateReceived,
            description=description,
            editors=editors,
            fundedBy=fundedBy,
            funders=funders,
            id=id,
            identifiers=identifiers,
            isPartOf=isPartOf,
            keywords=keywords,
            licenses=licenses,
            meta=meta,
            name=name,
            parts=parts,
            publisher=publisher,
            references=references,
            text=text,
            title=title,
            url=url,
            version=version
        )
        if caption is not None:
            self.caption = caption
        if label is not None:
            self.label = label


class Function(Entity):
    """
    A function with a name, which might take Parameters and return a value of a
    certain type.
    """

    name: Optional[str] = None
    parameters: Optional[Array["Parameter"]] = None
    returns: Optional["ValidatorTypes"] = None

    def __init__(
        self,
        id: Optional[str] = None,
        meta: Optional[Dict[str, Any]] = None,
        name: Optional[str] = None,
        parameters: Optional[Array["Parameter"]] = None,
        returns: Optional["ValidatorTypes"] = None
    ) -> None:
        super().__init__(
            id=id,
            meta=meta
        )
        if name is not None:
            self.name = name
        if parameters is not None:
            self.parameters = parameters
        if returns is not None:
            self.returns = returns


class Grant(Thing):
    """A grant, typically financial or otherwise quantifiable, of resources."""

    fundedItems: Optional[Array["Thing"]] = None
    sponsors: Optional[Array[Union["Person", "Organization"]]] = None

    def __init__(
        self,
        alternateNames: Optional[Array[str]] = None,
        description: Optional[Union[str, Array["Node"]]] = None,
        fundedItems: Optional[Array["Thing"]] = None,
        id: Optional[str] = None,
        identifiers: Optional[Array[Union[str, "PropertyValue"]]] = None,
        meta: Optional[Dict[str, Any]] = None,
        name: Optional[str] = None,
        sponsors: Optional[Array[Union["Person", "Organization"]]] = None,
        url: Optional[str] = None
    ) -> None:
        super().__init__(
            alternateNames=alternateNames,
            description=description,
            id=id,
            identifiers=identifiers,
            meta=meta,
            name=name,
            url=url
        )
        if fundedItems is not None:
            self.fundedItems = fundedItems
        if sponsors is not None:
            self.sponsors = sponsors


class Heading(Entity):
    """Heading"""

    content: Array["InlineContent"]
    depth: Optional[float] = None

    def __init__(
        self,
        content: Array["InlineContent"],
        depth: Optional[float] = None,
        id: Optional[str] = None,
        meta: Optional[Dict[str, Any]] = None
    ) -> None:
        super().__init__(
            id=id,
            meta=meta
        )
        if content is not None:
            self.content = content
        if depth is not None:
            self.depth = depth


class ImageObject(MediaObject):
    """An image file."""

    caption: Optional[str] = None
    thumbnail: Optional["ImageObject"] = None

    def __init__(
        self,
        contentUrl: str,
        alternateNames: Optional[Array[str]] = None,
        authors: Optional[Array[Union["Person", "Organization"]]] = None,
        bitrate: Optional[float] = None,
        caption: Optional[str] = None,
        content: Optional[Array["Node"]] = None,
        contentSize: Optional[float] = None,
        dateAccepted: Optional[Union["Date", str]] = None,
        dateCreated: Optional[Union["Date", str]] = None,
        dateModified: Optional[Union["Date", str]] = None,
        datePublished: Optional[Union["Date", str]] = None,
        dateReceived: Optional[Union["Date", str]] = None,
        description: Optional[Union[str, Array["Node"]]] = None,
        editors: Optional[Array["Person"]] = None,
        embedUrl: Optional[str] = None,
        format: Optional[str] = None,
        fundedBy: Optional[Array[Union["Grant", "MonetaryGrant"]]] = None,
        funders: Optional[Array[Union["Person", "Organization"]]] = None,
        id: Optional[str] = None,
        identifiers: Optional[Array[Union[str, "PropertyValue"]]] = None,
        isPartOf: Optional["CreativeWorkTypes"] = None,
        keywords: Optional[Array[str]] = None,
        licenses: Optional[Array[Union[str, "CreativeWorkTypes"]]] = None,
        meta: Optional[Dict[str, Any]] = None,
        name: Optional[str] = None,
        parts: Optional[Array["CreativeWorkTypes"]] = None,
        publisher: Optional[Union["Person", "Organization"]] = None,
        references: Optional[Array[Union[str, "CreativeWorkTypes"]]] = None,
        text: Optional[str] = None,
        thumbnail: Optional["ImageObject"] = None,
        title: Optional[Union[str, Array["Node"]]] = None,
        url: Optional[str] = None,
        version: Optional[Union[str, float]] = None
    ) -> None:
        super().__init__(
            contentUrl=contentUrl,
            alternateNames=alternateNames,
            authors=authors,
            bitrate=bitrate,
            content=content,
            contentSize=contentSize,
            dateAccepted=dateAccepted,
            dateCreated=dateCreated,
            dateModified=dateModified,
            datePublished=datePublished,
            dateReceived=dateReceived,
            description=description,
            editors=editors,
            embedUrl=embedUrl,
            format=format,
            fundedBy=fundedBy,
            funders=funders,
            id=id,
            identifiers=identifiers,
            isPartOf=isPartOf,
            keywords=keywords,
            licenses=licenses,
            meta=meta,
            name=name,
            parts=parts,
            publisher=publisher,
            references=references,
            text=text,
            title=title,
            url=url,
            version=version
        )
        if caption is not None:
            self.caption = caption
        if thumbnail is not None:
            self.thumbnail = thumbnail


class Include(Entity):
    """
    A directive to include content from an external source (e.g. file, URL) or
    content.
    """

    source: str
    content: Optional[Array["BlockContent"]] = None
    format: Optional[str] = None

    def __init__(
        self,
        source: str,
        content: Optional[Array["BlockContent"]] = None,
        format: Optional[str] = None,
        id: Optional[str] = None,
        meta: Optional[Dict[str, Any]] = None
    ) -> None:
        super().__init__(
            id=id,
            meta=meta
        )
        if source is not None:
            self.source = source
        if content is not None:
            self.content = content
        if format is not None:
            self.format = format


class NumberValidator(Entity):
    """A validator specifying the constraints on a numeric node."""

    exclusiveMaximum: Optional[float] = None
    exclusiveMinimum: Optional[float] = None
    maximum: Optional[float] = None
    minimum: Optional[float] = None
    multipleOf: Optional[float] = None

    def __init__(
        self,
        exclusiveMaximum: Optional[float] = None,
        exclusiveMinimum: Optional[float] = None,
        id: Optional[str] = None,
        maximum: Optional[float] = None,
        meta: Optional[Dict[str, Any]] = None,
        minimum: Optional[float] = None,
        multipleOf: Optional[float] = None
    ) -> None:
        super().__init__(
            id=id,
            meta=meta
        )
        if exclusiveMaximum is not None:
            self.exclusiveMaximum = exclusiveMaximum
        if exclusiveMinimum is not None:
            self.exclusiveMinimum = exclusiveMinimum
        if maximum is not None:
            self.maximum = maximum
        if minimum is not None:
            self.minimum = minimum
        if multipleOf is not None:
            self.multipleOf = multipleOf


class IntegerValidator(NumberValidator):
    """A validator specifying the constraints on an integer node."""

    def __init__(
        self,
        exclusiveMaximum: Optional[float] = None,
        exclusiveMinimum: Optional[float] = None,
        id: Optional[str] = None,
        maximum: Optional[float] = None,
        meta: Optional[Dict[str, Any]] = None,
        minimum: Optional[float] = None,
        multipleOf: Optional[float] = None
    ) -> None:
        super().__init__(
            exclusiveMaximum=exclusiveMaximum,
            exclusiveMinimum=exclusiveMinimum,
            id=id,
            maximum=maximum,
            meta=meta,
            minimum=minimum,
            multipleOf=multipleOf
        )



class Link(Entity):
    """
    A hyperlink to other pages, sections within the same document, resources,
    or any URL.
    """

    content: Array["InlineContent"]
    target: str
    exportFrom: Optional[str] = None
    importTo: Optional[str] = None
    relation: Optional[str] = None
    title: Optional[str] = None

    def __init__(
        self,
        content: Array["InlineContent"],
        target: str,
        exportFrom: Optional[str] = None,
        id: Optional[str] = None,
        importTo: Optional[str] = None,
        meta: Optional[Dict[str, Any]] = None,
        relation: Optional[str] = None,
        title: Optional[str] = None
    ) -> None:
        super().__init__(
            id=id,
            meta=meta
        )
        if content is not None:
            self.content = content
        if target is not None:
            self.target = target
        if exportFrom is not None:
            self.exportFrom = exportFrom
        if importTo is not None:
            self.importTo = importTo
        if relation is not None:
            self.relation = relation
        if title is not None:
            self.title = title


class List(Entity):
    """A list of items."""

    items: Array["ListItem"]
    order: Optional["EItemListOrder"] = None

    def __init__(
        self,
        items: Array["ListItem"],
        id: Optional[str] = None,
        meta: Optional[Dict[str, Any]] = None,
        order: Optional["EItemListOrder"] = None
    ) -> None:
        super().__init__(
            id=id,
            meta=meta
        )
        if items is not None:
            self.items = items
        if order is not None:
            self.order = order


class ListItem(Entity):
    """A single item in a list."""

    content: Array["Node"]
    checked: Optional[bool] = None

    def __init__(
        self,
        content: Array["Node"],
        checked: Optional[bool] = None,
        id: Optional[str] = None,
        meta: Optional[Dict[str, Any]] = None
    ) -> None:
        super().__init__(
            id=id,
            meta=meta
        )
        if content is not None:
            self.content = content
        if checked is not None:
            self.checked = checked


class Math(Entity):
    """A mathematical variable or equation."""

    text: str
    errors: Optional[Array[str]] = None
    mathLanguage: Optional[str] = None

    def __init__(
        self,
        text: str,
        errors: Optional[Array[str]] = None,
        id: Optional[str] = None,
        mathLanguage: Optional[str] = None,
        meta: Optional[Dict[str, Any]] = None
    ) -> None:
        super().__init__(
            id=id,
            meta=meta
        )
        if text is not None:
            self.text = text
        if errors is not None:
            self.errors = errors
        if mathLanguage is not None:
            self.mathLanguage = mathLanguage


class MathBlock(Math):
    """A block of math, e.g an equation, to be treated as block content."""

    def __init__(
        self,
        text: str,
        errors: Optional[Array[str]] = None,
        id: Optional[str] = None,
        mathLanguage: Optional[str] = None,
        meta: Optional[Dict[str, Any]] = None
    ) -> None:
        super().__init__(
            text=text,
            errors=errors,
            id=id,
            mathLanguage=mathLanguage,
            meta=meta
        )



class MathFragment(Math):
    """
    A fragment of math, e.g a variable name, to be treated as inline content.
    """

    def __init__(
        self,
        text: str,
        errors: Optional[Array[str]] = None,
        id: Optional[str] = None,
        mathLanguage: Optional[str] = None,
        meta: Optional[Dict[str, Any]] = None
    ) -> None:
        super().__init__(
            text=text,
            errors=errors,
            id=id,
            mathLanguage=mathLanguage,
            meta=meta
        )



class MonetaryGrant(Grant):
    """A monetary grant."""

    amounts: Optional[float] = None
    funders: Optional[Array[Union["Person", "Organization"]]] = None

    def __init__(
        self,
        alternateNames: Optional[Array[str]] = None,
        amounts: Optional[float] = None,
        description: Optional[Union[str, Array["Node"]]] = None,
        fundedItems: Optional[Array["Thing"]] = None,
        funders: Optional[Array[Union["Person", "Organization"]]] = None,
        id: Optional[str] = None,
        identifiers: Optional[Array[Union[str, "PropertyValue"]]] = None,
        meta: Optional[Dict[str, Any]] = None,
        name: Optional[str] = None,
        sponsors: Optional[Array[Union["Person", "Organization"]]] = None,
        url: Optional[str] = None
    ) -> None:
        super().__init__(
            alternateNames=alternateNames,
            description=description,
            fundedItems=fundedItems,
            id=id,
            identifiers=identifiers,
            meta=meta,
            name=name,
            sponsors=sponsors,
            url=url
        )
        if amounts is not None:
            self.amounts = amounts
        if funders is not None:
            self.funders = funders


class Organization(Thing):
    """An organization such as a school, NGO, corporation, club, etc."""

    address: Optional[str] = None
    brands: Optional[Array["Brand"]] = None
    contactPoints: Optional[Array["ContactPoint"]] = None
    departments: Optional[Array["Organization"]] = None
    funders: Optional[Array[Union["Organization", "Person"]]] = None
    legalName: Optional[str] = None
    logo: Optional[Union[str, "ImageObject"]] = None
    parentOrganization: Optional["Organization"] = None

    def __init__(
        self,
        address: Optional[str] = None,
        alternateNames: Optional[Array[str]] = None,
        brands: Optional[Array["Brand"]] = None,
        contactPoints: Optional[Array["ContactPoint"]] = None,
        departments: Optional[Array["Organization"]] = None,
        description: Optional[Union[str, Array["Node"]]] = None,
        funders: Optional[Array[Union["Organization", "Person"]]] = None,
        id: Optional[str] = None,
        identifiers: Optional[Array[Union[str, "PropertyValue"]]] = None,
        legalName: Optional[str] = None,
        logo: Optional[Union[str, "ImageObject"]] = None,
        meta: Optional[Dict[str, Any]] = None,
        name: Optional[str] = None,
        parentOrganization: Optional["Organization"] = None,
        url: Optional[str] = None
    ) -> None:
        super().__init__(
            alternateNames=alternateNames,
            description=description,
            id=id,
            identifiers=identifiers,
            meta=meta,
            name=name,
            url=url
        )
        if address is not None:
            self.address = address
        if brands is not None:
            self.brands = brands
        if contactPoints is not None:
            self.contactPoints = contactPoints
        if departments is not None:
            self.departments = departments
        if funders is not None:
            self.funders = funders
        if legalName is not None:
            self.legalName = legalName
        if logo is not None:
            self.logo = logo
        if parentOrganization is not None:
            self.parentOrganization = parentOrganization


class Paragraph(Entity):
    """Paragraph"""

    content: Array["InlineContent"]

    def __init__(
        self,
        content: Array["InlineContent"],
        id: Optional[str] = None,
        meta: Optional[Dict[str, Any]] = None
    ) -> None:
        super().__init__(
            id=id,
            meta=meta
        )
        if content is not None:
            self.content = content


class Variable(Entity):
    """A variable representing a name / value pair."""

    name: str
    readonly: Optional[bool] = None
    validator: Optional["ValidatorTypes"] = None
    value: Optional["Node"] = None

    def __init__(
        self,
        name: str,
        id: Optional[str] = None,
        meta: Optional[Dict[str, Any]] = None,
        readonly: Optional[bool] = None,
        validator: Optional["ValidatorTypes"] = None,
        value: Optional["Node"] = None
    ) -> None:
        super().__init__(
            id=id,
            meta=meta
        )
        if name is not None:
            self.name = name
        if readonly is not None:
            self.readonly = readonly
        if validator is not None:
            self.validator = validator
        if value is not None:
            self.value = value


class Parameter(Variable):
    """A parameter that can be set and used in evaluated code."""

    default: Optional["Node"] = None
    extends: Optional[bool] = None
    repeats: Optional[bool] = None
    required: Optional[bool] = None

    def __init__(
        self,
        name: str,
        default: Optional["Node"] = None,
        extends: Optional[bool] = None,
        id: Optional[str] = None,
        meta: Optional[Dict[str, Any]] = None,
        readonly: Optional[bool] = None,
        repeats: Optional[bool] = None,
        required: Optional[bool] = None,
        validator: Optional["ValidatorTypes"] = None,
        value: Optional["Node"] = None
    ) -> None:
        super().__init__(
            name=name,
            id=id,
            meta=meta,
            readonly=readonly,
            validator=validator,
            value=value
        )
        if default is not None:
            self.default = default
        if extends is not None:
            self.extends = extends
        if repeats is not None:
            self.repeats = repeats
        if required is not None:
            self.required = required


class Periodical(CreativeWork):
    """A periodical publication."""

    dateEnd: Optional[Union["Date", str]] = None
    dateStart: Optional[Union["Date", str]] = None
    issns: Optional[Array[str]] = None

    def __init__(
        self,
        alternateNames: Optional[Array[str]] = None,
        authors: Optional[Array[Union["Person", "Organization"]]] = None,
        content: Optional[Array["Node"]] = None,
        dateAccepted: Optional[Union["Date", str]] = None,
        dateCreated: Optional[Union["Date", str]] = None,
        dateEnd: Optional[Union["Date", str]] = None,
        dateModified: Optional[Union["Date", str]] = None,
        datePublished: Optional[Union["Date", str]] = None,
        dateReceived: Optional[Union["Date", str]] = None,
        dateStart: Optional[Union["Date", str]] = None,
        description: Optional[Union[str, Array["Node"]]] = None,
        editors: Optional[Array["Person"]] = None,
        fundedBy: Optional[Array[Union["Grant", "MonetaryGrant"]]] = None,
        funders: Optional[Array[Union["Person", "Organization"]]] = None,
        id: Optional[str] = None,
        identifiers: Optional[Array[Union[str, "PropertyValue"]]] = None,
        isPartOf: Optional["CreativeWorkTypes"] = None,
        issns: Optional[Array[str]] = None,
        keywords: Optional[Array[str]] = None,
        licenses: Optional[Array[Union[str, "CreativeWorkTypes"]]] = None,
        meta: Optional[Dict[str, Any]] = None,
        name: Optional[str] = None,
        parts: Optional[Array["CreativeWorkTypes"]] = None,
        publisher: Optional[Union["Person", "Organization"]] = None,
        references: Optional[Array[Union[str, "CreativeWorkTypes"]]] = None,
        text: Optional[str] = None,
        title: Optional[Union[str, Array["Node"]]] = None,
        url: Optional[str] = None,
        version: Optional[Union[str, float]] = None
    ) -> None:
        super().__init__(
            alternateNames=alternateNames,
            authors=authors,
            content=content,
            dateAccepted=dateAccepted,
            dateCreated=dateCreated,
            dateModified=dateModified,
            datePublished=datePublished,
            dateReceived=dateReceived,
            description=description,
            editors=editors,
            fundedBy=fundedBy,
            funders=funders,
            id=id,
            identifiers=identifiers,
            isPartOf=isPartOf,
            keywords=keywords,
            licenses=licenses,
            meta=meta,
            name=name,
            parts=parts,
            publisher=publisher,
            references=references,
            text=text,
            title=title,
            url=url,
            version=version
        )
        if dateEnd is not None:
            self.dateEnd = dateEnd
        if dateStart is not None:
            self.dateStart = dateStart
        if issns is not None:
            self.issns = issns


class Person(Thing):
    """A person (alive, dead, undead, or fictional)."""

    address: Optional[str] = None
    affiliations: Optional[Array["Organization"]] = None
    emails: Optional[Array[str]] = None
    familyNames: Optional[Array[str]] = None
    funders: Optional[Array[Union["Organization", "Person"]]] = None
    givenNames: Optional[Array[str]] = None
    honorificPrefix: Optional[str] = None
    honorificSuffix: Optional[str] = None
    jobTitle: Optional[str] = None
    memberOf: Optional[Array["Organization"]] = None
    telephoneNumbers: Optional[Array[str]] = None

    def __init__(
        self,
        address: Optional[str] = None,
        affiliations: Optional[Array["Organization"]] = None,
        alternateNames: Optional[Array[str]] = None,
        description: Optional[Union[str, Array["Node"]]] = None,
        emails: Optional[Array[str]] = None,
        familyNames: Optional[Array[str]] = None,
        funders: Optional[Array[Union["Organization", "Person"]]] = None,
        givenNames: Optional[Array[str]] = None,
        honorificPrefix: Optional[str] = None,
        honorificSuffix: Optional[str] = None,
        id: Optional[str] = None,
        identifiers: Optional[Array[Union[str, "PropertyValue"]]] = None,
        jobTitle: Optional[str] = None,
        memberOf: Optional[Array["Organization"]] = None,
        meta: Optional[Dict[str, Any]] = None,
        name: Optional[str] = None,
        telephoneNumbers: Optional[Array[str]] = None,
        url: Optional[str] = None
    ) -> None:
        super().__init__(
            alternateNames=alternateNames,
            description=description,
            id=id,
            identifiers=identifiers,
            meta=meta,
            name=name,
            url=url
        )
        if address is not None:
            self.address = address
        if affiliations is not None:
            self.affiliations = affiliations
        if emails is not None:
            self.emails = emails
        if familyNames is not None:
            self.familyNames = familyNames
        if funders is not None:
            self.funders = funders
        if givenNames is not None:
            self.givenNames = givenNames
        if honorificPrefix is not None:
            self.honorificPrefix = honorificPrefix
        if honorificSuffix is not None:
            self.honorificSuffix = honorificSuffix
        if jobTitle is not None:
            self.jobTitle = jobTitle
        if memberOf is not None:
            self.memberOf = memberOf
        if telephoneNumbers is not None:
            self.telephoneNumbers = telephoneNumbers


class Product(Thing):
    """
    Any offered product or service. For example, a pair of shoes; a haircut; or
    an episode of a TV show streamed online.
    """

    brands: Optional[Array["Brand"]] = None
    logo: Optional[Union[str, "ImageObject"]] = None
    productID: Optional[str] = None

    def __init__(
        self,
        alternateNames: Optional[Array[str]] = None,
        brands: Optional[Array["Brand"]] = None,
        description: Optional[Union[str, Array["Node"]]] = None,
        id: Optional[str] = None,
        identifiers: Optional[Array[Union[str, "PropertyValue"]]] = None,
        logo: Optional[Union[str, "ImageObject"]] = None,
        meta: Optional[Dict[str, Any]] = None,
        name: Optional[str] = None,
        productID: Optional[str] = None,
        url: Optional[str] = None
    ) -> None:
        super().__init__(
            alternateNames=alternateNames,
            description=description,
            id=id,
            identifiers=identifiers,
            meta=meta,
            name=name,
            url=url
        )
        if brands is not None:
            self.brands = brands
        if logo is not None:
            self.logo = logo
        if productID is not None:
            self.productID = productID


class PropertyValue(Thing):
    """A property-value pair."""

    value: "Node"
    propertyID: Optional[str] = None

    def __init__(
        self,
        value: "Node",
        alternateNames: Optional[Array[str]] = None,
        description: Optional[Union[str, Array["Node"]]] = None,
        id: Optional[str] = None,
        identifiers: Optional[Array[Union[str, "PropertyValue"]]] = None,
        meta: Optional[Dict[str, Any]] = None,
        name: Optional[str] = None,
        propertyID: Optional[str] = None,
        url: Optional[str] = None
    ) -> None:
        super().__init__(
            alternateNames=alternateNames,
            description=description,
            id=id,
            identifiers=identifiers,
            meta=meta,
            name=name,
            url=url
        )
        if value is not None:
            self.value = value
        if propertyID is not None:
            self.propertyID = propertyID


class PublicationIssue(CreativeWork):
    """
    A part of a successively published publication such as a periodical or
    publication volume, often numbered.
    """

    issueNumber: Optional[Union[str, int]] = None
    pageEnd: Optional[Union[str, int]] = None
    pageStart: Optional[Union[str, int]] = None
    pagination: Optional[str] = None

    def __init__(
        self,
        alternateNames: Optional[Array[str]] = None,
        authors: Optional[Array[Union["Person", "Organization"]]] = None,
        content: Optional[Array["Node"]] = None,
        dateAccepted: Optional[Union["Date", str]] = None,
        dateCreated: Optional[Union["Date", str]] = None,
        dateModified: Optional[Union["Date", str]] = None,
        datePublished: Optional[Union["Date", str]] = None,
        dateReceived: Optional[Union["Date", str]] = None,
        description: Optional[Union[str, Array["Node"]]] = None,
        editors: Optional[Array["Person"]] = None,
        fundedBy: Optional[Array[Union["Grant", "MonetaryGrant"]]] = None,
        funders: Optional[Array[Union["Person", "Organization"]]] = None,
        id: Optional[str] = None,
        identifiers: Optional[Array[Union[str, "PropertyValue"]]] = None,
        isPartOf: Optional["CreativeWorkTypes"] = None,
        issueNumber: Optional[Union[str, int]] = None,
        keywords: Optional[Array[str]] = None,
        licenses: Optional[Array[Union[str, "CreativeWorkTypes"]]] = None,
        meta: Optional[Dict[str, Any]] = None,
        name: Optional[str] = None,
        pageEnd: Optional[Union[str, int]] = None,
        pageStart: Optional[Union[str, int]] = None,
        pagination: Optional[str] = None,
        parts: Optional[Array["CreativeWorkTypes"]] = None,
        publisher: Optional[Union["Person", "Organization"]] = None,
        references: Optional[Array[Union[str, "CreativeWorkTypes"]]] = None,
        text: Optional[str] = None,
        title: Optional[Union[str, Array["Node"]]] = None,
        url: Optional[str] = None,
        version: Optional[Union[str, float]] = None
    ) -> None:
        super().__init__(
            alternateNames=alternateNames,
            authors=authors,
            content=content,
            dateAccepted=dateAccepted,
            dateCreated=dateCreated,
            dateModified=dateModified,
            datePublished=datePublished,
            dateReceived=dateReceived,
            description=description,
            editors=editors,
            fundedBy=fundedBy,
            funders=funders,
            id=id,
            identifiers=identifiers,
            isPartOf=isPartOf,
            keywords=keywords,
            licenses=licenses,
            meta=meta,
            name=name,
            parts=parts,
            publisher=publisher,
            references=references,
            text=text,
            title=title,
            url=url,
            version=version
        )
        if issueNumber is not None:
            self.issueNumber = issueNumber
        if pageEnd is not None:
            self.pageEnd = pageEnd
        if pageStart is not None:
            self.pageStart = pageStart
        if pagination is not None:
            self.pagination = pagination


class PublicationVolume(CreativeWork):
    """
    A part of a successively published publication such as a periodical or
    multi-volume work.
    """

    pageEnd: Optional[Union[str, int]] = None
    pageStart: Optional[Union[str, int]] = None
    pagination: Optional[str] = None
    volumeNumber: Optional[Union[str, int]] = None

    def __init__(
        self,
        alternateNames: Optional[Array[str]] = None,
        authors: Optional[Array[Union["Person", "Organization"]]] = None,
        content: Optional[Array["Node"]] = None,
        dateAccepted: Optional[Union["Date", str]] = None,
        dateCreated: Optional[Union["Date", str]] = None,
        dateModified: Optional[Union["Date", str]] = None,
        datePublished: Optional[Union["Date", str]] = None,
        dateReceived: Optional[Union["Date", str]] = None,
        description: Optional[Union[str, Array["Node"]]] = None,
        editors: Optional[Array["Person"]] = None,
        fundedBy: Optional[Array[Union["Grant", "MonetaryGrant"]]] = None,
        funders: Optional[Array[Union["Person", "Organization"]]] = None,
        id: Optional[str] = None,
        identifiers: Optional[Array[Union[str, "PropertyValue"]]] = None,
        isPartOf: Optional["CreativeWorkTypes"] = None,
        keywords: Optional[Array[str]] = None,
        licenses: Optional[Array[Union[str, "CreativeWorkTypes"]]] = None,
        meta: Optional[Dict[str, Any]] = None,
        name: Optional[str] = None,
        pageEnd: Optional[Union[str, int]] = None,
        pageStart: Optional[Union[str, int]] = None,
        pagination: Optional[str] = None,
        parts: Optional[Array["CreativeWorkTypes"]] = None,
        publisher: Optional[Union["Person", "Organization"]] = None,
        references: Optional[Array[Union[str, "CreativeWorkTypes"]]] = None,
        text: Optional[str] = None,
        title: Optional[Union[str, Array["Node"]]] = None,
        url: Optional[str] = None,
        version: Optional[Union[str, float]] = None,
        volumeNumber: Optional[Union[str, int]] = None
    ) -> None:
        super().__init__(
            alternateNames=alternateNames,
            authors=authors,
            content=content,
            dateAccepted=dateAccepted,
            dateCreated=dateCreated,
            dateModified=dateModified,
            datePublished=datePublished,
            dateReceived=dateReceived,
            description=description,
            editors=editors,
            fundedBy=fundedBy,
            funders=funders,
            id=id,
            identifiers=identifiers,
            isPartOf=isPartOf,
            keywords=keywords,
            licenses=licenses,
            meta=meta,
            name=name,
            parts=parts,
            publisher=publisher,
            references=references,
            text=text,
            title=title,
            url=url,
            version=version
        )
        if pageEnd is not None:
            self.pageEnd = pageEnd
        if pageStart is not None:
            self.pageStart = pageStart
        if pagination is not None:
            self.pagination = pagination
        if volumeNumber is not None:
            self.volumeNumber = volumeNumber


class Quote(Mark):
    """Inline, quoted content."""

    cite: Optional[Union["Cite", str]] = None

    def __init__(
        self,
        content: Array["InlineContent"],
        cite: Optional[Union["Cite", str]] = None,
        id: Optional[str] = None,
        meta: Optional[Dict[str, Any]] = None
    ) -> None:
        super().__init__(
            content=content,
            id=id,
            meta=meta
        )
        if cite is not None:
            self.cite = cite


class QuoteBlock(Entity):
    """A section quoted from somewhere else."""

    content: Array["BlockContent"]
    cite: Optional[Union["Cite", str]] = None

    def __init__(
        self,
        content: Array["BlockContent"],
        cite: Optional[Union["Cite", str]] = None,
        id: Optional[str] = None,
        meta: Optional[Dict[str, Any]] = None
    ) -> None:
        super().__init__(
            id=id,
            meta=meta
        )
        if content is not None:
            self.content = content
        if cite is not None:
            self.cite = cite


class SoftwareApplication(CreativeWork):
    """A software application."""

    softwareRequirements: Optional[Array["SoftwareApplication"]] = None
    softwareVersion: Optional[str] = None

    def __init__(
        self,
        alternateNames: Optional[Array[str]] = None,
        authors: Optional[Array[Union["Person", "Organization"]]] = None,
        content: Optional[Array["Node"]] = None,
        dateAccepted: Optional[Union["Date", str]] = None,
        dateCreated: Optional[Union["Date", str]] = None,
        dateModified: Optional[Union["Date", str]] = None,
        datePublished: Optional[Union["Date", str]] = None,
        dateReceived: Optional[Union["Date", str]] = None,
        description: Optional[Union[str, Array["Node"]]] = None,
        editors: Optional[Array["Person"]] = None,
        fundedBy: Optional[Array[Union["Grant", "MonetaryGrant"]]] = None,
        funders: Optional[Array[Union["Person", "Organization"]]] = None,
        id: Optional[str] = None,
        identifiers: Optional[Array[Union[str, "PropertyValue"]]] = None,
        isPartOf: Optional["CreativeWorkTypes"] = None,
        keywords: Optional[Array[str]] = None,
        licenses: Optional[Array[Union[str, "CreativeWorkTypes"]]] = None,
        meta: Optional[Dict[str, Any]] = None,
        name: Optional[str] = None,
        parts: Optional[Array["CreativeWorkTypes"]] = None,
        publisher: Optional[Union["Person", "Organization"]] = None,
        references: Optional[Array[Union[str, "CreativeWorkTypes"]]] = None,
        softwareRequirements: Optional[Array["SoftwareApplication"]] = None,
        softwareVersion: Optional[str] = None,
        text: Optional[str] = None,
        title: Optional[Union[str, Array["Node"]]] = None,
        url: Optional[str] = None,
        version: Optional[Union[str, float]] = None
    ) -> None:
        super().__init__(
            alternateNames=alternateNames,
            authors=authors,
            content=content,
            dateAccepted=dateAccepted,
            dateCreated=dateCreated,
            dateModified=dateModified,
            datePublished=datePublished,
            dateReceived=dateReceived,
            description=description,
            editors=editors,
            fundedBy=fundedBy,
            funders=funders,
            id=id,
            identifiers=identifiers,
            isPartOf=isPartOf,
            keywords=keywords,
            licenses=licenses,
            meta=meta,
            name=name,
            parts=parts,
            publisher=publisher,
            references=references,
            text=text,
            title=title,
            url=url,
            version=version
        )
        if softwareRequirements is not None:
            self.softwareRequirements = softwareRequirements
        if softwareVersion is not None:
            self.softwareVersion = softwareVersion


class SoftwareEnvironment(Thing):
    """A computational environment."""

    name: str
    adds: Optional[Array["SoftwareSourceCode"]] = None
    extends: Optional[Array["SoftwareEnvironment"]] = None
    removes: Optional[Array["SoftwareSourceCode"]] = None

    def __init__(
        self,
        name: str,
        adds: Optional[Array["SoftwareSourceCode"]] = None,
        alternateNames: Optional[Array[str]] = None,
        description: Optional[Union[str, Array["Node"]]] = None,
        extends: Optional[Array["SoftwareEnvironment"]] = None,
        id: Optional[str] = None,
        identifiers: Optional[Array[Union[str, "PropertyValue"]]] = None,
        meta: Optional[Dict[str, Any]] = None,
        removes: Optional[Array["SoftwareSourceCode"]] = None,
        url: Optional[str] = None
    ) -> None:
        super().__init__(
            name=name,
            alternateNames=alternateNames,
            description=description,
            id=id,
            identifiers=identifiers,
            meta=meta,
            url=url
        )
        if name is not None:
            self.name = name
        if adds is not None:
            self.adds = adds
        if extends is not None:
            self.extends = extends
        if removes is not None:
            self.removes = removes


class SoftwareSession(Thing):
    """
    Definition of a compute session, including its software and compute
    resource requirements and status.
    """

    clientsLimit: Optional[float] = None
    clientsRequest: Optional[float] = None
    cpuLimit: Optional[float] = None
    cpuRequest: Optional[float] = None
    dateEnd: Optional[Union["Date", str]] = None
    dateStart: Optional[Union["Date", str]] = None
    durationLimit: Optional[float] = None
    durationRequest: Optional[float] = None
    environment: Optional["SoftwareEnvironment"] = None
    memoryLimit: Optional[float] = None
    memoryRequest: Optional[float] = None
    networkTransferLimit: Optional[float] = None
    networkTransferRequest: Optional[float] = None
    status: Optional["ESessionStatus"] = None
    timeoutLimit: Optional[float] = None
    timeoutRequest: Optional[float] = None
    volumeMounts: Optional[Array["VolumeMount"]] = None

    def __init__(
        self,
        alternateNames: Optional[Array[str]] = None,
        clientsLimit: Optional[float] = None,
        clientsRequest: Optional[float] = None,
        cpuLimit: Optional[float] = None,
        cpuRequest: Optional[float] = None,
        dateEnd: Optional[Union["Date", str]] = None,
        dateStart: Optional[Union["Date", str]] = None,
        description: Optional[Union[str, Array["Node"]]] = None,
        durationLimit: Optional[float] = None,
        durationRequest: Optional[float] = None,
        environment: Optional["SoftwareEnvironment"] = None,
        id: Optional[str] = None,
        identifiers: Optional[Array[Union[str, "PropertyValue"]]] = None,
        memoryLimit: Optional[float] = None,
        memoryRequest: Optional[float] = None,
        meta: Optional[Dict[str, Any]] = None,
        name: Optional[str] = None,
        networkTransferLimit: Optional[float] = None,
        networkTransferRequest: Optional[float] = None,
        status: Optional["ESessionStatus"] = None,
        timeoutLimit: Optional[float] = None,
        timeoutRequest: Optional[float] = None,
        url: Optional[str] = None,
        volumeMounts: Optional[Array["VolumeMount"]] = None
    ) -> None:
        super().__init__(
            alternateNames=alternateNames,
            description=description,
            id=id,
            identifiers=identifiers,
            meta=meta,
            name=name,
            url=url
        )
        if clientsLimit is not None:
            self.clientsLimit = clientsLimit
        if clientsRequest is not None:
            self.clientsRequest = clientsRequest
        if cpuLimit is not None:
            self.cpuLimit = cpuLimit
        if cpuRequest is not None:
            self.cpuRequest = cpuRequest
        if dateEnd is not None:
            self.dateEnd = dateEnd
        if dateStart is not None:
            self.dateStart = dateStart
        if durationLimit is not None:
            self.durationLimit = durationLimit
        if durationRequest is not None:
            self.durationRequest = durationRequest
        if environment is not None:
            self.environment = environment
        if memoryLimit is not None:
            self.memoryLimit = memoryLimit
        if memoryRequest is not None:
            self.memoryRequest = memoryRequest
        if networkTransferLimit is not None:
            self.networkTransferLimit = networkTransferLimit
        if networkTransferRequest is not None:
            self.networkTransferRequest = networkTransferRequest
        if status is not None:
            self.status = status
        if timeoutLimit is not None:
            self.timeoutLimit = timeoutLimit
        if timeoutRequest is not None:
            self.timeoutRequest = timeoutRequest
        if volumeMounts is not None:
            self.volumeMounts = volumeMounts


class SoftwareSourceCode(CreativeWork):
    """
    Computer programming source code. Example: Full (compile ready) solutions,
    code snippet samples, scripts, templates.
    """

    codeRepository: Optional[str] = None
    codeSampleType: Optional[str] = None
    maintainers: Optional[Array[Union["Organization", "Person"]]] = None
    programmingLanguage: Optional[str] = None
    runtimePlatform: Optional[Array[str]] = None
    softwareRequirements: Optional[Array[Union["SoftwareSourceCode", "SoftwareApplication", str]]] = None
    targetProducts: Optional[Array["SoftwareApplication"]] = None

    def __init__(
        self,
        alternateNames: Optional[Array[str]] = None,
        authors: Optional[Array[Union["Person", "Organization"]]] = None,
        codeRepository: Optional[str] = None,
        codeSampleType: Optional[str] = None,
        content: Optional[Array["Node"]] = None,
        dateAccepted: Optional[Union["Date", str]] = None,
        dateCreated: Optional[Union["Date", str]] = None,
        dateModified: Optional[Union["Date", str]] = None,
        datePublished: Optional[Union["Date", str]] = None,
        dateReceived: Optional[Union["Date", str]] = None,
        description: Optional[Union[str, Array["Node"]]] = None,
        editors: Optional[Array["Person"]] = None,
        fundedBy: Optional[Array[Union["Grant", "MonetaryGrant"]]] = None,
        funders: Optional[Array[Union["Person", "Organization"]]] = None,
        id: Optional[str] = None,
        identifiers: Optional[Array[Union[str, "PropertyValue"]]] = None,
        isPartOf: Optional["CreativeWorkTypes"] = None,
        keywords: Optional[Array[str]] = None,
        licenses: Optional[Array[Union[str, "CreativeWorkTypes"]]] = None,
        maintainers: Optional[Array[Union["Organization", "Person"]]] = None,
        meta: Optional[Dict[str, Any]] = None,
        name: Optional[str] = None,
        parts: Optional[Array["CreativeWorkTypes"]] = None,
        programmingLanguage: Optional[str] = None,
        publisher: Optional[Union["Person", "Organization"]] = None,
        references: Optional[Array[Union[str, "CreativeWorkTypes"]]] = None,
        runtimePlatform: Optional[Array[str]] = None,
        softwareRequirements: Optional[Array[Union["SoftwareSourceCode", "SoftwareApplication", str]]] = None,
        targetProducts: Optional[Array["SoftwareApplication"]] = None,
        text: Optional[str] = None,
        title: Optional[Union[str, Array["Node"]]] = None,
        url: Optional[str] = None,
        version: Optional[Union[str, float]] = None
    ) -> None:
        super().__init__(
            alternateNames=alternateNames,
            authors=authors,
            content=content,
            dateAccepted=dateAccepted,
            dateCreated=dateCreated,
            dateModified=dateModified,
            datePublished=datePublished,
            dateReceived=dateReceived,
            description=description,
            editors=editors,
            fundedBy=fundedBy,
            funders=funders,
            id=id,
            identifiers=identifiers,
            isPartOf=isPartOf,
            keywords=keywords,
            licenses=licenses,
            meta=meta,
            name=name,
            parts=parts,
            publisher=publisher,
            references=references,
            text=text,
            title=title,
            url=url,
            version=version
        )
        if codeRepository is not None:
            self.codeRepository = codeRepository
        if codeSampleType is not None:
            self.codeSampleType = codeSampleType
        if maintainers is not None:
            self.maintainers = maintainers
        if programmingLanguage is not None:
            self.programmingLanguage = programmingLanguage
        if runtimePlatform is not None:
            self.runtimePlatform = runtimePlatform
        if softwareRequirements is not None:
            self.softwareRequirements = softwareRequirements
        if targetProducts is not None:
            self.targetProducts = targetProducts


class StringValidator(Entity):
    """A schema specifying constraints on a string node."""

    maxLength: Optional[float] = None
    minLength: Optional[float] = None
    pattern: Optional[str] = None

    def __init__(
        self,
        id: Optional[str] = None,
        maxLength: Optional[float] = None,
        meta: Optional[Dict[str, Any]] = None,
        minLength: Optional[float] = None,
        pattern: Optional[str] = None
    ) -> None:
        super().__init__(
            id=id,
            meta=meta
        )
        if maxLength is not None:
            self.maxLength = maxLength
        if minLength is not None:
            self.minLength = minLength
        if pattern is not None:
            self.pattern = pattern


class Strong(Mark):
    """Strongly emphasised content."""

    def __init__(
        self,
        content: Array["InlineContent"],
        id: Optional[str] = None,
        meta: Optional[Dict[str, Any]] = None
    ) -> None:
        super().__init__(
            content=content,
            id=id,
            meta=meta
        )



class Subscript(Mark):
    """Subscripted content."""

    def __init__(
        self,
        content: Array["InlineContent"],
        id: Optional[str] = None,
        meta: Optional[Dict[str, Any]] = None
    ) -> None:
        super().__init__(
            content=content,
            id=id,
            meta=meta
        )



class Superscript(Mark):
    """Superscripted content."""

    def __init__(
        self,
        content: Array["InlineContent"],
        id: Optional[str] = None,
        meta: Optional[Dict[str, Any]] = None
    ) -> None:
        super().__init__(
            content=content,
            id=id,
            meta=meta
        )



class Table(CreativeWork):
    """A table."""

    rows: Array["TableRow"]

    def __init__(
        self,
        rows: Array["TableRow"],
        alternateNames: Optional[Array[str]] = None,
        authors: Optional[Array[Union["Person", "Organization"]]] = None,
        content: Optional[Array["Node"]] = None,
        dateAccepted: Optional[Union["Date", str]] = None,
        dateCreated: Optional[Union["Date", str]] = None,
        dateModified: Optional[Union["Date", str]] = None,
        datePublished: Optional[Union["Date", str]] = None,
        dateReceived: Optional[Union["Date", str]] = None,
        description: Optional[Union[str, Array["Node"]]] = None,
        editors: Optional[Array["Person"]] = None,
        fundedBy: Optional[Array[Union["Grant", "MonetaryGrant"]]] = None,
        funders: Optional[Array[Union["Person", "Organization"]]] = None,
        id: Optional[str] = None,
        identifiers: Optional[Array[Union[str, "PropertyValue"]]] = None,
        isPartOf: Optional["CreativeWorkTypes"] = None,
        keywords: Optional[Array[str]] = None,
        licenses: Optional[Array[Union[str, "CreativeWorkTypes"]]] = None,
        meta: Optional[Dict[str, Any]] = None,
        name: Optional[str] = None,
        parts: Optional[Array["CreativeWorkTypes"]] = None,
        publisher: Optional[Union["Person", "Organization"]] = None,
        references: Optional[Array[Union[str, "CreativeWorkTypes"]]] = None,
        text: Optional[str] = None,
        title: Optional[Union[str, Array["Node"]]] = None,
        url: Optional[str] = None,
        version: Optional[Union[str, float]] = None
    ) -> None:
        super().__init__(
            alternateNames=alternateNames,
            authors=authors,
            content=content,
            dateAccepted=dateAccepted,
            dateCreated=dateCreated,
            dateModified=dateModified,
            datePublished=datePublished,
            dateReceived=dateReceived,
            description=description,
            editors=editors,
            fundedBy=fundedBy,
            funders=funders,
            id=id,
            identifiers=identifiers,
            isPartOf=isPartOf,
            keywords=keywords,
            licenses=licenses,
            meta=meta,
            name=name,
            parts=parts,
            publisher=publisher,
            references=references,
            text=text,
            title=title,
            url=url,
            version=version
        )
        if rows is not None:
            self.rows = rows


class TableCell(Entity):
    """A cell within a `Table`."""

    content: Array["Node"]
    cellType: Optional["ECellType"] = None
    colspan: Optional[int] = None
    name: Optional[str] = None
    rowspan: Optional[int] = None

    def __init__(
        self,
        content: Array["Node"],
        cellType: Optional["ECellType"] = None,
        colspan: Optional[int] = None,
        id: Optional[str] = None,
        meta: Optional[Dict[str, Any]] = None,
        name: Optional[str] = None,
        rowspan: Optional[int] = None
    ) -> None:
        super().__init__(
            id=id,
            meta=meta
        )
        if content is not None:
            self.content = content
        if cellType is not None:
            self.cellType = cellType
        if colspan is not None:
            self.colspan = colspan
        if name is not None:
            self.name = name
        if rowspan is not None:
            self.rowspan = rowspan


class TableRow(Entity):
    """A row within a Table."""

    cells: Array["TableCell"]
    rowType: Optional["ERowType"] = None

    def __init__(
        self,
        cells: Array["TableCell"],
        id: Optional[str] = None,
        meta: Optional[Dict[str, Any]] = None,
        rowType: Optional["ERowType"] = None
    ) -> None:
        super().__init__(
            id=id,
            meta=meta
        )
        if cells is not None:
            self.cells = cells
        if rowType is not None:
            self.rowType = rowType


class ThematicBreak(Entity):
    """
    A thematic break, such as a scene change in a story, a transition to
    another topic, or a new document.
    """

    def __init__(
        self,
        id: Optional[str] = None,
        meta: Optional[Dict[str, Any]] = None
    ) -> None:
        super().__init__(
            id=id,
            meta=meta
        )



class TupleValidator(Entity):
    """
    A validator specifying constraints on an array of heterogeneous items.
    """

    items: Optional[Array["ValidatorTypes"]] = None

    def __init__(
        self,
        id: Optional[str] = None,
        items: Optional[Array["ValidatorTypes"]] = None,
        meta: Optional[Dict[str, Any]] = None
    ) -> None:
        super().__init__(
            id=id,
            meta=meta
        )
        if items is not None:
            self.items = items


class VideoObject(MediaObject):
    """A video file."""

    caption: Optional[str] = None
    thumbnail: Optional["ImageObject"] = None
    transcript: Optional[str] = None

    def __init__(
        self,
        contentUrl: str,
        alternateNames: Optional[Array[str]] = None,
        authors: Optional[Array[Union["Person", "Organization"]]] = None,
        bitrate: Optional[float] = None,
        caption: Optional[str] = None,
        content: Optional[Array["Node"]] = None,
        contentSize: Optional[float] = None,
        dateAccepted: Optional[Union["Date", str]] = None,
        dateCreated: Optional[Union["Date", str]] = None,
        dateModified: Optional[Union["Date", str]] = None,
        datePublished: Optional[Union["Date", str]] = None,
        dateReceived: Optional[Union["Date", str]] = None,
        description: Optional[Union[str, Array["Node"]]] = None,
        editors: Optional[Array["Person"]] = None,
        embedUrl: Optional[str] = None,
        format: Optional[str] = None,
        fundedBy: Optional[Array[Union["Grant", "MonetaryGrant"]]] = None,
        funders: Optional[Array[Union["Person", "Organization"]]] = None,
        id: Optional[str] = None,
        identifiers: Optional[Array[Union[str, "PropertyValue"]]] = None,
        isPartOf: Optional["CreativeWorkTypes"] = None,
        keywords: Optional[Array[str]] = None,
        licenses: Optional[Array[Union[str, "CreativeWorkTypes"]]] = None,
        meta: Optional[Dict[str, Any]] = None,
        name: Optional[str] = None,
        parts: Optional[Array["CreativeWorkTypes"]] = None,
        publisher: Optional[Union["Person", "Organization"]] = None,
        references: Optional[Array[Union[str, "CreativeWorkTypes"]]] = None,
        text: Optional[str] = None,
        thumbnail: Optional["ImageObject"] = None,
        title: Optional[Union[str, Array["Node"]]] = None,
        transcript: Optional[str] = None,
        url: Optional[str] = None,
        version: Optional[Union[str, float]] = None
    ) -> None:
        super().__init__(
            contentUrl=contentUrl,
            alternateNames=alternateNames,
            authors=authors,
            bitrate=bitrate,
            content=content,
            contentSize=contentSize,
            dateAccepted=dateAccepted,
            dateCreated=dateCreated,
            dateModified=dateModified,
            datePublished=datePublished,
            dateReceived=dateReceived,
            description=description,
            editors=editors,
            embedUrl=embedUrl,
            format=format,
            fundedBy=fundedBy,
            funders=funders,
            id=id,
            identifiers=identifiers,
            isPartOf=isPartOf,
            keywords=keywords,
            licenses=licenses,
            meta=meta,
            name=name,
            parts=parts,
            publisher=publisher,
            references=references,
            text=text,
            title=title,
            url=url,
            version=version
        )
        if caption is not None:
            self.caption = caption
        if thumbnail is not None:
            self.thumbnail = thumbnail
        if transcript is not None:
            self.transcript = transcript


class VolumeMount(Thing):
    """Describes a volume mount from a host to container."""

    mountDestination: str
    mountOptions: Optional[Array[str]] = None
    mountSource: Optional[str] = None
    mountType: Optional[str] = None

    def __init__(
        self,
        mountDestination: str,
        alternateNames: Optional[Array[str]] = None,
        description: Optional[Union[str, Array["Node"]]] = None,
        id: Optional[str] = None,
        identifiers: Optional[Array[Union[str, "PropertyValue"]]] = None,
        meta: Optional[Dict[str, Any]] = None,
        mountOptions: Optional[Array[str]] = None,
        mountSource: Optional[str] = None,
        mountType: Optional[str] = None,
        name: Optional[str] = None,
        url: Optional[str] = None
    ) -> None:
        super().__init__(
            alternateNames=alternateNames,
            description=description,
            id=id,
            identifiers=identifiers,
            meta=meta,
            name=name,
            url=url
        )
        if mountDestination is not None:
            self.mountDestination = mountDestination
        if mountOptions is not None:
            self.mountOptions = mountOptions
        if mountSource is not None:
            self.mountSource = mountSource
        if mountType is not None:
            self.mountType = mountType


"""
Union type for valid block content.
"""
BlockContent = Union["CodeBlock", "CodeChunk", "Heading", "List", "ListItem", "MathBlock", "Paragraph", "QuoteBlock", "Table", "ThematicBreak"]


"""
All type schemas that are derived from CodeBlock
"""
CodeBlockTypes = Union["CodeBlock", "CodeChunk"]


"""
All type schemas that are derived from CodeFragment
"""
CodeFragmentTypes = Union["CodeFragment", "CodeExpression"]


"""
All type schemas that are derived from Code
"""
CodeTypes = Union["Code", "CodeBlock", "CodeChunk", "CodeExpression", "CodeFragment"]


"""
All type schemas that are derived from CreativeWork
"""
CreativeWorkTypes = Union["CreativeWork", "Article", "AudioObject", "Collection", "Datatable", "Figure", "ImageObject", "MediaObject", "Periodical", "PublicationIssue", "PublicationVolume", "SoftwareApplication", "SoftwareSourceCode", "Table", "VideoObject"]


"""
All type schemas that are derived from Entity
"""
EntityTypes = Union["Entity", "ArrayValidator", "Article", "AudioObject", "BooleanValidator", "Brand", "Cite", "CiteGroup", "Code", "CodeBlock", "CodeChunk", "CodeError", "CodeExpression", "CodeFragment", "Collection", "ConstantValidator", "ContactPoint", "CreativeWork", "Datatable", "DatatableColumn", "Date", "Delete", "Emphasis", "EnumValidator", "Figure", "Function", "Grant", "Heading", "ImageObject", "Include", "IntegerValidator", "Link", "List", "ListItem", "Mark", "Math", "MathBlock", "MathFragment", "MediaObject", "MonetaryGrant", "NumberValidator", "Organization", "Paragraph", "Parameter", "Periodical", "Person", "Product", "PropertyValue", "PublicationIssue", "PublicationVolume", "Quote", "QuoteBlock", "SoftwareApplication", "SoftwareEnvironment", "SoftwareSession", "SoftwareSourceCode", "StringValidator", "Strong", "Subscript", "Superscript", "Table", "TableCell", "TableRow", "ThematicBreak", "Thing", "TupleValidator", "Variable", "VideoObject", "VolumeMount"]


"""
All type schemas that are derived from Grant
"""
GrantTypes = Union["Grant", "MonetaryGrant"]


"""
Union type for valid inline content.
"""
InlineContent = Union[None, bool, int, float, str, "CodeFragment", "CodeExpression", "Delete", "Emphasis", "ImageObject", "Link", "MathFragment", "Quote", "Strong", "Subscript", "Superscript", "Cite", "CiteGroup"]


"""
All type schemas that are derived from Mark
"""
MarkTypes = Union["Mark", "Delete", "Emphasis", "Quote", "Strong", "Subscript", "Superscript"]


"""
All type schemas that are derived from Math
"""
MathTypes = Union["Math", "MathBlock", "MathFragment"]


"""
All type schemas that are derived from MediaObject
"""
MediaObjectTypes = Union["MediaObject", "AudioObject", "ImageObject", "VideoObject"]


"""
Union type for all valid nodes.
"""
Node = Union[None, bool, float, int, str, Array[Any], Dict[str, Any], "Entity"]


"""
All type schemas that are derived from NumberValidator
"""
NumberValidatorTypes = Union["NumberValidator", "IntegerValidator"]


"""
All type schemas that are derived from Thing
"""
ThingTypes = Union["Thing", "Article", "AudioObject", "Brand", "Collection", "ContactPoint", "CreativeWork", "Datatable", "DatatableColumn", "Figure", "Grant", "ImageObject", "MediaObject", "MonetaryGrant", "Organization", "Periodical", "Person", "Product", "PropertyValue", "PublicationIssue", "PublicationVolume", "SoftwareApplication", "SoftwareEnvironment", "SoftwareSession", "SoftwareSourceCode", "Table", "VideoObject", "VolumeMount"]


"""
Union type for all validator types.
"""
ValidatorTypes = Union["ConstantValidator", "EnumValidator", "BooleanValidator", "NumberValidator", "IntegerValidator", "StringValidator", "ArrayValidator", "TupleValidator"]


"""
All type schemas that are derived from Variable
"""
VariableTypes = Union["Variable", "Parameter"]

